var OAuthSimple;if(OAuthSimple===undefined){OAuthSimple=function(a,b){this._secrets={};this._parameters={};if(a!==undefined){this._secrets.consumer_key=a}if(b!==undefined){this._secrets.shared_secret=b}this._default_signature_method="HMAC-SHA1";this._action="GET";this._nonce_chars="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";this.reset=function(){this._parameters={};this._path=undefined;return this};this.setParameters=function(c){if(c===undefined){c={}}if(typeof(c)=="string"){c=this._parseParameterString(c)}this._parameters=c;if(this._parameters.oauth_nonce===undefined){this._getNonce()}if(this._parameters.oauth_timestamp===undefined){this._getTimestamp()}if(this._parameters.oauth_method===undefined){this.setSignatureMethod()}if(this._parameters.oauth_consumer_key===undefined){this._getApiKey()}if(this._parameters.oauth_token===undefined){this._getAccessToken()}return this};this.setQueryString=function(c){return this.setParameters(c)};this.setURL=function(c){if(c==""){throw ("No path specified for OAuthSimple.setURL")}this._path=c;return this};this.setPath=function(c){return this.setURL(c)};this.setAction=function(c){if(c===undefined){c="GET"}c=c.toUpperCase();if(c.match("[^A-Z]")){throw ("Invalid action specified for OAuthSimple.setAction")}this._action=c;return this};this.setTokensAndSecrets=function(d){if(d){for(var c in d){this._secrets[c]=d[c]}}if(this._secrets.api_key){this._secrets.consumer_key=this._secrets.api_key}if(this._secrets.access_token){this._secrets.oauth_token=this._secrets.access_token}if(this._secrets.access_secret){this._secrets.oauth_secret=this._secrets.access_secret}if(this._secrets.consumer_key===undefined){throw ("Missing required consumer_key in OAuthSimple.setTokensAndSecrets")}if(this._secrets.shared_secret===undefined){throw ("Missing required shared_secret in OAuthSimple.setTokensAndSecrets")}if((this._secrets.oauth_token!==undefined)&&(this._secrets.oauth_secret===undefined)){throw ("Missing oauth_secret for supplied oauth_token in OAuthSimple.setTokensAndSecrets")}return this};this.setSignatureMethod=function(c){if(c===undefined){c=this._default_signature_method}if(c.toUpperCase().match(/(PLAINTEXT|HMAC-SHA1)/)===undefined){throw ("Unknown signing method specified for OAuthSimple.setSignatureMethod")}this._parameters.oauth_signature_method=c.toUpperCase();return this};this.sign=function(d){if(d===undefined){d={}}if(d.action!==undefined){this.setAction(d.action)}if(d.path!==undefined){this.setPath(d.path)}if(d.method!==undefined){this.setSignatureMethod(d.method)}this.setTokensAndSecrets(d.signatures);if(d.parameters!==undefined){this.setParameters(d.parameters)}var c=this._normalizedParameters();this._parameters.oauth_signature=this._generateSignature(c);return{parameters:this._parameters,signature:this._oauthEscape(this._parameters.oauth_signature),signed_url:this._path+"?"+this._normalizedParameters(),header:this.getHeaderString()}};this.getHeaderString=function(g){if(this._parameters.oauth_signature===undefined){this.sign(g)}var c="OAuth ";for(var d in this._parameters){if(!d.match(/^oauth/)){continue}if((this._parameters[d]) instanceof Array){var e=this._parameters[d].length;for(var f=0;f<e;f++){c+=d+'="'+this._oauthEscape(this._parameters[d][f])+'" '}}else{c+=d+'="'+this._oauthEscape(this._parameters[d])+'" '}}return c};this._parseParameterString=function(h){var g=h.split("&");var c={};for(var d=g.shift();d;d=g.shift()){var e=d.split("=");var f="";if(e[1]){f=decodeURIComponent(e[1])}if(c[e[0]]){if(!(c[e[0]] instanceof Array)){c[e[0]]=Array(c[e[0]],f)}else{c[e[0]].push(f)}}else{c[e[0]]=f}}return c};this._oauthEscape=function(c){if(c===undefined){return""}if(c instanceof Array){throw ("Array passed to _oauthEscape")}return encodeURIComponent(c).replace(/\!/g,"%21").replace(/\*/g,"%2A").replace(/'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29")};this._getNonce=function(f){if(f===undefined){f=5}var c="";var g=this._nonce_chars.length;for(var e=0;e<f;e++){var d=Math.floor(Math.random()*g);c+=this._nonce_chars.substring(d,d+1)}this._parameters.oauth_nonce=c;return c};this._getApiKey=function(){if(this._secrets.consumer_key===undefined){throw ("No consumer_key set for OAuthSimple.")}this._parameters.oauth_consumer_key=this._secrets.consumer_key;return this._parameters.oauth_consumer_key};this._getAccessToken=function(){if(this._secrets.oauth_secret===undefined){return""}if(this._secrets.oauth_token===undefined){throw ("No oauth_token (access_token) set for OAuthSimple.")}this._parameters.oauth_token=this._secrets.oauth_token;return this._parameters.oauth_token};this._getTimestamp=function(){var e=new Date();var c=Math.floor(e.getTime()/1000);this._parameters.oauth_timestamp=c;return c};this.b64_hmac_sha1=function(g,l,c,m){if(!c){c="="}if(!m){m=8}function i(r,k,u,s){if(r<20){return(k&u)|((~k)&s)}if(r<40){return k^u^s}if(r<60){return(k&u)|(k&s)|(u&s)}return k^u^s}function f(d){return(d<20)?1518500249:(d<40)?1859775393:(d<60)?-1894007588:-899497514}function p(k,s){var r=(k&65535)+(s&65535),d=(k>>16)+(s>>16)+(r>>16);return(d<<16)|(r&65535)}function q(k,d){return(k<<d)|(k>>>(32-d))}function j(H,z){H[z>>5]|=128<<(24-z%32);H[((z+64>>9)<<4)+15]=z;var I=[80],G=1732584193,F=-271733879,E=-1732584194,D=271733878,C=-1009589776;for(var B=0;B<H.length;B+=16){var y=G,v=F,u=E,k=D,K=C;for(var A=0;A<80;A++){if(A<16){I[A]=H[B+A]}else{I[A]=q(I[A-3]^I[A-8]^I[A-14]^I[A-16],1)}var J=p(p(q(G,5),i(A,F,E,D)),p(p(C,I[A]),f(A)));C=D;D=E;E=q(F,30);F=G;G=J}G=p(G,y);F=p(F,v);E=p(E,u);D=p(D,k);C=p(C,K)}return[G,F,E,D,C]}function n(t){var k=[],d=(1<<m)-1;for(var r=0;r<t.length*m;r+=m){k[r>>5]|=(t.charCodeAt(r/8)&d)<<(32-m-r%32)}return k}function h(s,x){var r=n(s);if(r.length>16){r=j(r,s.length*m)}var v=[16],w=[16];for(var t=0;t<16;t++){v[t]=r[t]^909522486;w[t]=r[t]^1549556828}var u=j(v.concat(n(x)),512+x.length*m);return j(w.concat(u),512+160)}function e(d){var v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="";for(var u=0;u<d.length*4;u+=3){var x=(((d[u>>2]>>8*(3-u%4))&255)<<16)|(((d[u+1>>2]>>8*(3-(u+1)%4))&255)<<8)|((d[u+2>>2]>>8*(3-(u+2)%4))&255);for(var k=0;k<4;k++){if(u*8+k*6>d.length*32){w+=c}else{w+=v.charAt((x>>6*(3-k))&63)}}}return w}function o(r,s){return e(h(r,s))}return o(g,l)};this._normalizedParameters=function(){var f=new Array();var l=[];var k=0;for(var g in this._parameters){if(k++>1000){throw ("runaway 1")}l.unshift(g)}l=l.sort();pLen=l.length;for(var e=0;e<pLen;e++){g=l[e];if(g.match(/\w+_secret/)){continue}if(this._parameters[g] instanceof Array){var c=this._parameters[g].sort();var h=c.length;for(var d=0;d<h;d++){if(k++>1000){throw ("runaway 1")}f.push(this._oauthEscape(g)+"="+this._oauthEscape(c[d]))}continue}f.push(this._oauthEscape(g)+"="+this._oauthEscape(this._parameters[g]))}return f.join("&")};this._generateSignature=function(){var c=this._oauthEscape(this._secrets.shared_secret)+"&"+this._oauthEscape(this._secrets.oauth_secret);if(this._parameters.oauth_signature_method=="PLAINTEXT"){return c}if(this._parameters.oauth_signature_method=="HMAC-SHA1"){var d=this._oauthEscape(this._action)+"&"+this._oauthEscape(this._path)+"&"+this._oauthEscape(this._normalizedParameters());return this.b64_hmac_sha1(c,d)}return null};return this}};